#include "network/Packet.h"

InPacket::InPacket(ENetPacket* packet) : packet(packet), readIndex(0) {
}

bool InPacket::read(void* buffer, unsigned int length) {
    if(readIndex + length > packet->dataLength) {
        return true;
    }
    memcpy(buffer, packet->data + readIndex, length);
    readIndex += length;
    return false;
}

bool InPacket::read(uint8& u) {
    return read(&u, sizeof(u));
}

bool InPacket::read(uint16& u) {
    if(read(&u, sizeof(u))) {
        return true;
    }
    u = ntohs(u);
    return false;
}

bool InPacket::read(uint32& u) {
    if(read(&u, sizeof(u))) {
        return true;
    }
    u = ntohl(u);
    return false;
}
